/*
   Test VRfMin, VRfMax, VRfSum, and VRfCheckSym

   $Id: tVRx2v.c 1.11 2001/01/12 libtsp-v4r0 $
*/

#include <libtsp.h>

#define NMAX	128


int
main (int argc, const char *argv[])

{
  double xd[NMAX], yd[NMAX];
  float xs[NMAX], ys[NMAX];
  int i, k, Nx, Ny;
  const char *cr;
  char *rout;
  double xx;

  cr = argv[1];
  k = 2;

  for (i = 0; k < argc; ++i, ++k) {
    if (strcmp (argv[k], "//") == 0)
      break;
    sscanf (argv[k], "%lg", &xd[i]);
    xs[i] = xd[i];
  }
  Nx = i;

  ++k;
  for (i = 0; k < argc; ++k, ++i) {
    sscanf (argv[k], "%lg", &yd[i]);
    ys[i] = yd[i];
  }
  Ny = i;

  if (Ny == 0)
    VRdPrint (stdout, "Input data:", xd, Nx);
  else {
    VRdPrint (stdout, "x:", xd, Nx);
    VRdPrint (stdout, "y:", yd, Ny);
  }

  rout = "";
  xx = -999999;

  if (strcmp(cr, "fC") == 0) {
    rout = "VRfCorSym";
    xx = VRfCorSym (xs, Nx);
  }
  else if (strcmp (cr, "fL") == 0) {
    rout = "VRfMin";
    xx = VRfMin (xs, Nx);
  }
  else if (strcmp(cr, "fU") == 0) {
    rout = "VRfMax";
    xx = VRfMax (xs, Nx);
  }
  else if (strcmp(cr, "fS") == 0) {
    rout = "VRfSum";
    xx = VRfSum (xs, Nx);
  }
  else if (strcmp(cr, "dC") == 0) {
    rout = "VRdCorSym";
    xx = VRdCorSym (xd, Nx);
  }
  else if (strcmp(cr, "fD") == 0) {
    rout = "VRfDotProd";
    xx = VRfDotProd(xs, ys, Nx);
  }
  else if (strcmp(cr, "dD") == 0) {
    rout = "VRdDotProd";
    xx = VRdDotProd(xd, yd, Nx);
  }

  printf ("%s: %g\n", rout, xx);

  return 0;
}
