/*
   Test VR vector to vector routines

   $Id: tVRx2y.c 1.8 2000/12/18 libtsp-v4r0 $
*/

#include <string.h>

#include <libtsp.h>

#define NMAX	128


int
main (int argc, const char *argv[])

{
  double xd[NMAX], yd[NMAX];
  float xs[NMAX], ys[NMAX];
  int i, k, N;
  const char *cr;
  char *rout;

  cr = argv[1];
  k = 2;
  N = argc - k;

  for (i = 0; i < N; ++i, ++k) {
    sscanf (argv[k], "%lg", &xd[i]);
    xs[i] = xd[i];
  }
  VRdPrint (stdout, "Input data:", xd, N);

  rout = "";
  if (strcmp(cr, "dE") == 0) {
    rout = "VRdSymPart: Even part";
    VRdSymPart (1, xd, yd, N);
  }
  else if (strcmp(cr, "dO") == 0) {
    rout = "VRdSymPart: Odd part";
    VRdSymPart (-1, xd, yd, N);
  }
  else if (strcmp(cr, "dC") == 0) {
    rout = "VRdCopy:";
    VRdCopy (xd, yd, N);
  }
  else if (strcmp(cr, "fC") == 0) {
    rout = "VRfCopy:";
    VRfCopy (xs, ys, N);
  }
  else if (strcmp(cr, "fL") == 0) {
    rout = "VRfLog10:";
    VRfLog10 (xs, ys, N);
  }
  else if (strcmp(cr, "fP") == 0) {
    rout = "VRfPow10:";
    VRfPow10 (xs, ys, N);
  }
  else if (strcmp(cr, "fA") == 0) {
    rout = "VRfAmpldB:";
    VRfAmpldB (xs, ys, N);
  }
  else if (strcmp(cr, "fR") == 0) {
    rout = "VRfRev:";
    VRfRev (xs, ys, N);
  }

  if (cr[0] == 'd')
    VRdPrint (stdout, rout, yd, N);
  else
    VRfPrint (stdout, rout, ys, N);

  return 0;
}
